//---------------------------------------------------------------------------
#include <WiFi.h>
//---------------------------------------------------------------------------
String WiFi_SSID = "your ssid";
String WiFi_Password = "your password";
//---------------------------------------------------------------------------
uint16_t   TCP_Port = 8090;
WiFiServer TCP_Server(TCP_Port, 1);
WiFiClient TCP_Client;
//---------------------------------------------------------------------------
boolean WIFI_Init()
{
	//初始化Wifi
	WiFi.mode(WIFI_STA);
	WiFi.setSleep(false);

	//连接Wifi
	WiFi.begin(WiFi_SSID.c_str(), WiFi_Password.c_str());

	//判断是否连接
	unsigned long nTime = millis();
	while ((WiFi.status() != WL_CONNECTED) && (millis() - nTime < 10000)) delay(100);
	return (WiFi.status() == WL_CONNECTED);
}
//---------------------------------------------------------------------------
boolean TCP_Server_Init()
{
	//建立TCP Server
	TCP_Server.begin();
	TCP_Server.setNoDelay(true);
	return TCP_Server;
}
//---------------------------------------------------------------------------
String WIFI_Receive()
{
	String strReceive = "";
	if (TCP_Server.hasClient()) TCP_Client = TCP_Server.available();
	if (TCP_Client.connected() && TCP_Client.available()) strReceive = TCP_Client.readStringUntil('\n');
	return strReceive;
}
//---------------------------------------------------------------------------
void WIFI_Send(String strSend)
{
	if (TCP_Server.hasClient()) TCP_Client = TCP_Server.available();
	if (TCP_Client.connected())
	{
		strSend += "\n";
		TCP_Client.write_P(strSend.c_str(), strSend.length());
	}
}
//---------------------------------------------------------------------------
