//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MSCommLib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	FboolMouseDown = false;
	FstrCOMrx = "";

	#ifdef USE_SERIAL
		Label1->Caption = "COM";  EditIP->Text   = "1";
		Label2->Caption = "Baud"; EditPort->Text = "19200";
	#endif

	for (int nIndex = 0; nIndex < 100; nIndex++)
	{
		AnsiString strEditName = IntToStr(nIndex);
		while (strEditName.Length() < 2) strEditName = "0" + strEditName;
		strEditName = "Edit" + strEditName;

		TEdit* Edit = (TEdit*)FindComponent(strEditName);
		if (Edit != NULL) SetEditAlignRight(Edit);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	Ctrl_Disconnect();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MSCommComm(TObject *Sender)
{
/*
	CommEvent
	1仺еַSthreshold
	2ջյRthresholdַ
	3CTS߷仯
	4DSR߷仯
	5CD߷仯
	6⵽ź
	10Ǵ
*/

	if (MSComm->CommEvent == comEvReceive)
	{
		if (MSComm->InBufferCount > 0)
		{
			AnsiString strReceive = MSComm->Input.AsType(varString);
			FstrCOMrx += strReceive;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerTimer(TObject *Sender)
{
	while (true)
	{
		AnsiString strReceive = Ctrl_Receive();
		if (strReceive.IsEmpty()) break;

		AnsiString strCtrlType = strReceive.SubString(1, 2);
		strReceive.Delete(1, 2);

		TEdit* Edit = (TEdit*)FindComponent("Edit" + strCtrlType);
		if (Edit != NULL)
		{
			if (! Edit->Focused()) Edit->Text = strReceive;
		}
		else
		{
			MemoReceive->Lines->Add("receive: " + strCtrlType + strReceive);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnReconnectClick(TObject *Sender)
{
	Ctrl_Disconnect();
	Ctrl_Connect();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditSendKeyPress(TObject *Sender, char &Key)
{
	if (Key == VK_RETURN) EditSend->SelectAll(); else return; 
	Ctrl_Connect();

	AnsiString strSend = EditSend->Text;
	if (strSend.IsEmpty()) return;

	Ctrl_Send(strSend);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnStopClick(TObject *Sender)
{
	AnsiString strCtrlType = "";
	float fCtrlValue = 0;

	if      (Sender == BtnStop)			{strCtrlType = "A0"; Edit22->Text = FloatToStr(0);                             Edit23->Text = FloatToStr(0);         }
	else if (Sender == BtnForward)		{strCtrlType = "A2"; fCtrlValue = StrToFloat(Edit22->Text) + Edit22->Tag / 10; Edit22->Text = FloatToStr(fCtrlValue);}
	else if (Sender == BtnBackward)		{strCtrlType = "A2"; fCtrlValue = StrToFloat(Edit22->Text) - Edit22->Tag / 10; Edit22->Text = FloatToStr(fCtrlValue);}
	else if (Sender == BtnTurnLeft)		{strCtrlType = "A3"; fCtrlValue = StrToFloat(Edit23->Text) + Edit23->Tag / 4;  Edit23->Text = FloatToStr(fCtrlValue);}
	else if (Sender == BtnTurnRight)	{strCtrlType = "A3"; fCtrlValue = StrToFloat(Edit23->Text) - Edit23->Tag / 4;  Edit23->Text = FloatToStr(fCtrlValue);}

	Ctrl_Send(strCtrlType + "/" + FloatToStr(fCtrlValue));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnStopKeyPress(TObject *Sender, char &Key)
{
	AnsiString strKey = Key;
	strKey = strKey.UpperCase();

	if      (strKey == "G") BtnStopClick(BtnStop);
	else if (strKey == "W") BtnStopClick(BtnForward);
	else if (strKey == "S") BtnStopClick(BtnBackward);
	else if (strKey == "A") BtnStopClick(BtnTurnLeft);
	else if (strKey == "D") BtnStopClick(BtnTurnRight);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PanelMouseMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
	FboolMouseDown = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PanelMouseMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
	if (! FboolMouseDown) return;

	if (X < 0) X = 0; if (X > PanelMouse->Width ) X = PanelMouse->Width;
	if (Y < 0) Y = 0; if (Y > PanelMouse->Height) Y = PanelMouse->Height;

	int nMoveSpeed = Edit22->Tag - (float)Y / PanelMouse->Height * Edit22->Tag * 2;
	int nTurnSpeed = Edit23->Tag - (float)X / PanelMouse->Width  * Edit23->Tag * 2;

	Edit22->Text = IntToStr(nMoveSpeed);
	Edit23->Text = IntToStr(nTurnSpeed);
	PanelMouse->Caption = Edit22->Text + ", " + Edit23->Text;

	Ctrl_Send("A2/" + Edit22->Text, false);
	Ctrl_Send("A3/" + Edit23->Text, false);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PanelMouseMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
	FboolMouseDown = false;
	Edit22->Text = FloatToStr(0);
	Edit23->Text = FloatToStr(0);
	PanelMouse->Caption = ".";
	Ctrl_Send("A0/0", false);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit21KeyPress(TObject *Sender, char &Key)
{
	TEdit* Edit = (TEdit*)Sender;
	if (Key == VK_RETURN) Edit->SelectAll(); else return;

	AnsiString strCtrlType = "";

	if      (Sender == Edit21) strCtrlType = "A1";
	else if (Sender == Edit22) strCtrlType = "A2";
	else if (Sender == Edit23) strCtrlType = "A3";
	else if (Sender == Edit28) strCtrlType = "A8";
	else if (Sender == Edit29) strCtrlType = "A9";
	else if (Sender == Edit31) strCtrlType = "B1";
	else if (Sender == Edit32) strCtrlType = "B2";
	else if (Sender == Edit33) strCtrlType = "B3";
	else if (Sender == Edit34) strCtrlType = "B4";
	else if (Sender == Edit35) strCtrlType = "B5";
	else if (Sender == Edit36) strCtrlType = "B6";
	else if (Sender == Edit41) strCtrlType = "C1";
	else if (Sender == Edit42) strCtrlType = "C2";
	else if (Sender == Edit43) strCtrlType = "C3";
	else if (Sender == Edit44) strCtrlType = "C4";
	else if (Sender == Edit45) strCtrlType = "C5";
	else if (Sender == Edit46) strCtrlType = "C6";
	else if (Sender == Edit51) strCtrlType = "D1";
	else if (Sender == Edit52) strCtrlType = "D2";
	else if (Sender == Edit53) strCtrlType = "D3";
	else if (Sender == Edit54) strCtrlType = "D4";
	else if (Sender == Edit55) strCtrlType = "D5";
	else if (Sender == Edit56) strCtrlType = "D6";
	else if (Sender == Edit91) strCtrlType = "F1";
	else if (Sender == Edit92) strCtrlType = "F2";
	else if (Sender == Edit93) strCtrlType = "F3";

	Ctrl_Send(strCtrlType + "/" + Edit->Text);
}
//---------------------------------------------------------------------------
void TForm1::SetEditAlignRight(TEdit* Edit)
{
	SetWindowLong(Edit->Handle, GWL_STYLE, GetWindowLong(Edit->Handle, GWL_STYLE) | ES_RIGHT);
	Edit->Invalidate();
}
//---------------------------------------------------------------------------
void TForm1::Ctrl_Connect()
{
	if (Ctrl_Connected()) return;

	#ifdef USE_WIFI
		try
		{
			TCPClient->Host = EditIP->Text;
			TCPClient->Port = StrToInt(EditPort->Text);
			TCPClient->Connect();
		}
		catch(...)
		{
			//
		}
	#endif

	#ifdef USE_SERIAL
		try
		{
			MSComm->CommPort   = StrToInt(EditIP->Text);
			MSComm->Settings   = EditPort->Text + ",n,8,1";
			MSComm->InputMode  = 0;		//ݵĸʽ0ı1
			MSComm->RThreshold = 1;		//1ַʹOnComm¼
			MSComm->PortOpen   = true;
		}
		catch(...)
		{
			//
		}
	#endif

	if (Ctrl_Connected())
	{
		MemoReceive->Lines->Add("connect success");
		Timer->Enabled = true;
	}
	else
	{
		MemoReceive->Lines->Add("connect failure");
		Timer->Enabled = false;
	}
}
//---------------------------------------------------------------------------
void TForm1::Ctrl_Disconnect()
{
	if (! Ctrl_Connected()) return;

	#ifdef USE_WIFI
		TCPClient->Disconnect();
	#endif

	#ifdef USE_SERIAL
		MSComm->PortOpen = false;
	#endif
}
//---------------------------------------------------------------------------
bool TForm1::Ctrl_Connected()
{
	#ifdef USE_WIFI
		return TCPClient->Connected();
	#endif

	#ifdef USE_SERIAL
		return MSComm->PortOpen;
	#endif
}
//---------------------------------------------------------------------------
bool TForm1::Ctrl_Send(AnsiString strSend, bool boolAddMemo)
{
	if (! Ctrl_Connected()) return false;
	if (boolAddMemo) MemoReceive->Lines->Add("send: " + strSend);

	unsigned char nChecksum = 0;
	for (int nIndex = 1; nIndex <= strSend.Length(); nIndex++) nChecksum += (unsigned char)strSend[nIndex];
	strSend += (char)nChecksum;

	#ifdef USE_WIFI
		TCPClient->Write(strSend + "\n");
	#endif

	#ifdef USE_SERIAL
		MSComm->Output = StringToOleStr(strSend + "\n");
	#endif

	return true;
}
//---------------------------------------------------------------------------
AnsiString TForm1::Ctrl_Receive()
{
	AnsiString strReceive = "";
	if (! Ctrl_Connected()) return strReceive;

	AnsiString strCtrlReceive = "";

	#ifdef USE_WIFI
		strCtrlReceive = TCPClient->ReadLn("\n", 5);
		if (TCPClient->ReadLnTimedOut) strCtrlReceive = "";
	#endif

	#ifdef USE_SERIAL
		int nPos = FstrCOMrx.Pos("\n");
		if (nPos > 0)
		{
			strCtrlReceive = FstrCOMrx.SubString(1, nPos - 1);
			FstrCOMrx.Delete(1, nPos);
		}
	#endif

	if (strCtrlReceive.SubString(3, 1) == "/")
	{
		unsigned char nChecksum = 0;
		for (int nIndex = 1; nIndex <= strCtrlReceive.Length() - 1; nIndex++) nChecksum += (unsigned char)strCtrlReceive[nIndex];
		if (nChecksum == (unsigned char)strCtrlReceive[strCtrlReceive.Length()]) strReceive = strCtrlReceive.SubString(1, 2) + strCtrlReceive.SubString(4, strCtrlReceive.Length() - 4);
	}

	return strReceive;
}
//---------------------------------------------------------------------------

