//---------------------------------------------------------------------------
#include <BluetoothSerial.h>
//---------------------------------------------------------------------------
#define BT_SERIAL_Name			"ESP32_BT_SERIAL_JOYSTICK"
#define BT_SERIAL_Name_Remote	"ESP32_BT_SERIAL"
//---------------------------------------------------------------------------
BluetoothSerial BTSerial;
//---------------------------------------------------------------------------
bool Connected = false;  //是否连接成功
//---------------------------------------------------------------------------
bool BT_SERIAL_Connected()
{
	Connected = (BTSerial.connected() && BTSerial.hasClient());
	return Connected;
}
//---------------------------------------------------------------------------
bool BT_SERIAL_KeepConnect()
{
	if (! BT_SERIAL_Connected())
	{
		if (BTSerial.connected()) BTSerial.disconnect();
		BTSerial.connect(BT_SERIAL_Name_Remote);

		Serial.print("BT SERIAL "); Serial.print(BT_SERIAL_Name_Remote); Serial.print(" connect ");
		if (BT_SERIAL_Connected()) Serial.println("success"); else Serial.println("failure");
	}

	return Connected;
}
//---------------------------------------------------------------------------
bool BT_SERIAL_Init()
{
	//初始化BT设备
	if (BTSerial.begin(BT_SERIAL_Name, true))
	{
		Serial.print("BT SERIAL Name: ");
		Serial.println(BT_SERIAL_Name);
		return true;
	}
	else
	{
		Serial.println("BT SERIAL begin failure");
		return false;
	}
}
//---------------------------------------------------------------------------
String BT_SERIAL_Receive()
{
	String strReceive = "";

	if (BT_SERIAL_Connected())
	{
		static String BTReceive = "";
		while (BTSerial.available()) BTReceive += (char)BTSerial.read();

		int nIndex = BTReceive.indexOf("\n");
		if (nIndex >= 0)
		{
			strReceive = BTReceive.substring(0, nIndex);
			BTReceive = BTReceive.substring(nIndex + 1, BTReceive.length());
		}
	}

	return strReceive;
}
//---------------------------------------------------------------------------
void BT_SERIAL_Send(String strSend)
{
	if (BT_SERIAL_Connected())
	{
		strSend += "\n";
		BTSerial.write((uint8_t*)strSend.c_str(), strSend.length());
	}
}
//---------------------------------------------------------------------------
