//---------------------------------------------------------------------------
//#define USE_WIFI
//#define USE_BLE
#define USE_BT_SERIAL
#define USE_WIRELESS_SERIAL
//---------------------------------------------------------------------------
#include <Adafruit_ST7789.h>
#include <EEPROM.h>
#include "MPU6050.h"
//---------------------------------------------------------------------------
#ifdef USE_WIFI
	#include "WIFI.h"
#endif
//---------------------------------------------------------------------------
#ifdef USE_BLE
	#include "BLE.h"
#endif
//---------------------------------------------------------------------------
#ifdef USE_BT_SERIAL
	#include "BT_SERIAL.h"
#endif
//---------------------------------------------------------------------------
#ifdef USE_WIRELESS_SERIAL
	#include "WIRELESS_SERIAL.h"
#endif
//---------------------------------------------------------------------------
//急停引脚
#define		EmeStop_Pin		13		//急停（HIGH）
//---------------------------------------------------------------------------
//电压ADC引脚
#define		Power_Pin		34		//电位器抽头
//---------------------------------------------------------------------------
//显示屏引脚
#define		TFT_SCL_Pin		18		//VSPI CLK
#define		TFT_SDA_Pin		23		//VSPI MOSI
#define		TFT_RST_Pin		27		//reset
#define		TFT_DC_Pin		26		//data or command
#define		TFT_CS_Pin		25		//chip select
#define		TFT_BLK_Pin		33		//back light
//---------------------------------------------------------------------------
//MPU6050引脚
#define		MPU6050_RX_Pin	17		//模块RX（TX2引脚）
#define		MPU6050_TX_Pin	16		//模块TX（RX2引脚）
//---------------------------------------------------------------------------
//无线透传引脚
#define		Wireless_RX_Pin	15		//模块RX
#define		Wireless_TX_Pin	4		//模块TX
#define		Wireless_CS_Pin	22		//模块片选（低电平唤醒，高电平睡眠）
//---------------------------------------------------------------------------
#define		CtrlTime		100		//控制周期（毫秒）
//---------------------------------------------------------------------------
#define		MoveAngleMin	5		//移动角度最小值
#define		MoveAngleMax	60		//移动角度最大值
#define		MoveSpeedMax	130		//移动速度最大值
//---------------------------------------------------------------------------
#define		TurnAngleMin	5		//转向角度最小值
#define		TurnAngleMax	60		//转向角度最大值
#define		TurnSpeedMax	150		//转向速度最大值
//---------------------------------------------------------------------------
Adafruit_ST7789 tft = Adafruit_ST7789(TFT_CS_Pin, TFT_DC_Pin, TFT_RST_Pin);		//ST7789显示屏
int			Power_Percent;			//供电电量百分比
TMPU6050	MPU6050;				//MPU6050姿态
bool		USE_Communicate;		//是否启用数据通讯功能
//---------------------------------------------------------------------------
int			AutoPatrol		= 0;	//是否自动巡逻
int			DataReceived	= 0;	//是否接收到数据
//---------------------------------------------------------------------------
int			DisplayType		= 1;	//显示内容，0：关闭显示；1-n：显示内容
int			WIRELESS_SERIAL_Baud;	//WIRELESS_SERIAL波特率
int			Power_BatteryNum;		//供电电池数量
//---------------------------------------------------------------------------
//接收反馈数据
int			F_PIDTimeLoop;				//实际PID计算周期（毫秒）
float		F_AngleX;					//MPU6050姿态，X轴角度
float		F_AngleY;					//MPU6050姿态，Y轴角度
float		F_AngleZ;					//MPU6050姿态，Z轴角度
float		F_GyroX;					//MPU6050姿态，X轴角速度
float		F_GyroY;					//MPU6050姿态，Y轴角速度
float		F_GyroZ;					//MPU6050姿态，Z轴角速度
float		F_AccX;						//MPU6050姿态，X轴加速度
float		F_AccY;						//MPU6050姿态，Y轴加速度
float		F_AccZ;						//MPU6050姿态，Z轴加速度
int			F_SR04;						//SR04超声波测距
int			F_PWM;						//PWM
int			F_PWMTurn;					//转向PWM
int			F_L_PWM;					//左轮PWM
int			F_R_PWM;					//右轮PWM
int			F_L_ENC_Count;				//左轮编码器计数总计
int			F_R_ENC_Count;				//右轮编码器计数总计
int			F_Power_Percent;			//供电电量百分比
float		F_Balance;					//平衡角度（°）
float		F_MoveSpeed;				//移动速度（一个PID计算周期内左右编码器计数之和）
float		F_TurnSpeed;				//转向角速度（°/s）
int			F_AutoPatrol;				//是否自动巡逻
int			F_Feedback;					//是否反馈数据
int			F_EmergencyStopStatus;		//急停状态
int			F_WIRELESS_SERIAL_Baud;		//WIRELESS_SERIAL波特率
int			F_Feedback_Interval;		//反馈数据间隔时间
int			F_Power_BatteryNum;			//供电电池数量
float		F_kap, F_ksp, F_ktp;		//比例系数
float		F_kai, F_ksi, F_kti;		//积分系数
float		F_kad, F_ksd, F_ktd;		//微分系数
float		F_kaf, F_ksf, F_ktf;		//低通滤波
float		F_kam, F_ksm, F_ktm;		//整体比例（静止状态，12V）
float		F_kan, F_ksn, F_ktn;		//整体比例（运动状态，12V）
//---------------------------------------------------------------------------
