//---------------------------------------------------------------------------
#include <WiFi.h>
//---------------------------------------------------------------------------
String WiFi_SSID = "your ssid";
String WiFi_Password = "your password";
//---------------------------------------------------------------------------
String     TCP_IP   = "192.168.1.1";  //TCP Server IP
uint16_t   TCP_Port = 8090;
WiFiClient TCP_Client;
//---------------------------------------------------------------------------
bool Connected = false;  //是否连接成功
//---------------------------------------------------------------------------
bool WIFI_KeepConnect()
{
	Connected = ((WiFi.status() == WL_CONNECTED) && TCP_Client.connected());
	if (! Connected) if (WIFI_Init()) TCP_Client_Init();
	return Connected;
}
//---------------------------------------------------------------------------
boolean WIFI_Init()
{
	//初始化Wifi
	WiFi.mode(WIFI_STA);
	WiFi.setSleep(false);

	//连接Wifi
	WiFi.begin(WiFi_SSID.c_str(), WiFi_Password.c_str());

	//判断是否连接
	unsigned long nTime = millis();
	while ((WiFi.status() != WL_CONNECTED) && (millis() - nTime < 10000)) delay(100);
	return (WiFi.status() == WL_CONNECTED);
}
//---------------------------------------------------------------------------
boolean TCP_Client_Init()
{
	//建立TCP Client
	TCP_Client.connect(TCP_IP.c_str(), TCP_Port);
	TCP_Client.setNoDelay(true);
	Connected = TCP_Client.connected();
	return Connected;
}
//---------------------------------------------------------------------------
String WIFI_Receive()
{
	String strReceive = "";
	if (TCP_Client.connected() && TCP_Client.available()) strReceive = TCP_Client.readStringUntil('\n');
	return strReceive;
}
//---------------------------------------------------------------------------
void WIFI_Send(String strSend)
{
	if (TCP_Client.connected())
	{
		strSend += "\n";
		TCP_Client.write_P(strSend.c_str(), strSend.length());
	}
}
//---------------------------------------------------------------------------
